%kmdl		fuse

Name:           fuse
Version:        2.7.4
Release:        8_12%{?dist}
Summary:        File System in Userspace (FUSE) utilities

Group:          System Environment/Base
License:        GPL+
URL:            http://fuse.sf.net
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
Source1:	fuse-udev.nodes
Source2:	fuse-makedev.d-fuse

Patch0:		fuse-udev_rules.patch
Patch1:		fuse-openfix.patch
Patch2:         fuse-chkconfig_support.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
#Requires:	kernel >= 2.6.14
Requires:	which
BuildRequires:	libselinux-devel
#kmdl_parentdependencies

Requires(post): /sbin/chkconfig
Requires(post):	/sbin/MAKEDEV
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(postun):/sbin/service

%description
With FUSE it is possible to implement a fully functional filesystem in a
userspace program. This package contains the FUSE userspace tools to
mount a FUSE filesystem.

%package libs
Summary:        File System in Userspace (FUSE) libraries
Group:          System Environment/Libraries
License:        LGPLv2+

%description libs
Devel With FUSE it is possible to implement a fully functional filesystem in a
userspace program. This package contains the FUSE libraries.


%package devel
Summary:        File System in Userspace (FUSE) devel files
Group:          Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	pkgconfig
License:        LGPLv2+

%description devel
With FUSE it is possible to implement a fully functional filesystem in a
userspace program. This package contains development files (headers,
pgk-config) to develop FUSE based applications/filesystems.

%package -n %kmdl_name
%kmdl_dependencies
Summary:    fuse kernel module.
Group: System Environment/Kernel

%description -n %kmdl_name
With FUSE it is possible to implement a fully functional filesystem in a
userspace program. This package contains the FUSE kernel module.

%kmdl_desc

%prep
%setup -q
#disable device creation during build/install
sed -i 's|mknod|echo Disabled: mknod |g' util/Makefile.in
%patch0 -p0 -b .patch0
%patch1 -p0 -b .patch1
%patch2 -p0 -b .patch2

%build
%if %{kmdl_userland}
# Can't pass --disable-static here, or else the utils don't build
%configure \
 --disable-kernel-module \
 --libdir=/%{_lib} \
 --bindir=/bin \
 --exec-prefix=/
make %{?_smp_mflags}
%else
%kmdl_config
%configure \
  --disable-lib \
  --disable-util \
  --disable-example \
  --enable-kernel-module \
  --with-kernel=%{kmdl_kernelsrcdir}

if test -f %{kmdl_kernelsrcdir}/include/linux/mutex.h \
  && grep -v mutex_destoy %{kmdl_kernelsrcdir}/include/linux/mutex.h > /dev/null; then
  # we have an incomplete mutex implementation
  sed -i -e's,#define HAVE_MUTEX_H 1,/* #undef HAVE_MUTEX_H */,' kernel/config.h
fi
make %{?_smp_mflags}
%endif


%install
rm -rf $RPM_BUILD_ROOT

%if %{kmdl_userland}

make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'
# FIXME change from 60 to 99
install -D -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/udev/makedev.d/99-fuse.nodes
install -D -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/makedev.d/z-fuse
# change from 4755 to 0755 to allow stripping -- fixed later in files
chmod 0755 $RPM_BUILD_ROOT/bin/fusermount
# Put pc file in correct place
mkdir -p $RPM_BUILD_ROOT%{_libdir}
mv $RPM_BUILD_ROOT/%{_lib}/pkgconfig $RPM_BUILD_ROOT%{_libdir}

# Get rid of static libs
rm -f $RPM_BUILD_ROOT/%{_lib}/*.a

# Compatibility symlinks
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cd $RPM_BUILD_ROOT%{_bindir}
ln -s /bin/fusermount fusermount
ln -s /bin/ulockmgr_server ulockmgr_server

%else

mkdir -p %{buildroot}%{kmdl_moduledir}/fs/fuse
install -c -m 0644 kernel/fuse.ko %{buildroot}%{kmdl_moduledir}/fs/fuse/

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/MAKEDEV fuse
/sbin/chkconfig --add fuse

%preun
if [ $1 = 0 ]; then
        /sbin/service fuse stop >/dev/null 2>&1
        /sbin/chkconfig --del fuse
fi

%postun
if [ "$1" -ge "1" ]; then
        /sbin/service fuse condrestart >/dev/null 2>&1 || :
fi

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%if %{kmdl_userland}
%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING FAQ Filesystems NEWS README README.NFS
/sbin/mount.fuse
%attr(4755,root,root) /bin/fusermount
/bin/ulockmgr_server
%{_sysconfdir}/init.d/fuse
%{_sysconfdir}/makedev.d/z-fuse
# Compat symlinks
%{_bindir}/fusermount
%{_bindir}/ulockmgr_server
%config %{_sysconfdir}/udev/rules.d/99-fuse.rules
%config %{_sysconfdir}/udev/makedev.d/99-fuse.nodes

%files libs
%defattr(-,root,root,-)
%doc COPYING.LIB
/%{_lib}/libfuse.so.*
/%{_lib}/libulockmgr.so.*

%files devel
%defattr(-,root,root,-)
/%{_lib}/libfuse.so
/%{_lib}/libulockmgr.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/fuse.h
%{_includedir}/ulockmgr.h
%{_includedir}/fuse

%else
%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}
%endif

%changelog
* Mon Nov 24 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.7.4-8_11
- Sync with rawhide.

* Sat Jul 26 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.7.4-8_10
- Update to 2.7.4.

* Tue Feb 19 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.7.3-8_9
- Update to 2.7.3.

* Sat Dec 29 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.7.2-8_8
- Update to 2.7.2.

* Tue Oct 23 2007 Paulo Roma <roma@lcg.ufrj.br> - 2.7.1-6_7
- Update to 2.7.1.

* Mon Oct  1 2007 Peter Lemenkov <lemenkov@gmail.com> 2.7.0-6
- Added Require: which (BZ#312511)

* Wed Jul 25 2007 Paulo Roma <roma@lcg.ufrj.br> - 2.7.0-3_7
- Update to 2.7.0.

* Sun Jul 22 2007 Tom "spot" Callaway <tcallawa@redhat.com> 2.7.0-3
- put pkgconfig file in correct place
- enable compat symlinks for files in /bin

* Sat Jul 21 2007 Tom "spot" Callaway <tcallawa@redhat.com> 2.7.0-2
- redefine exec_prefix to /
- redefine bindir to /bin
- redefine libdir to %%{_lib}
- don't pass --disable-static to configure
- manually rm generated static libs

* Wed Jul 18 2007 Peter Lemenkov <lemenkov@gmail.com> 2.7.0-1
- Redefined exec_prefix due to demands from NTFS-3G

* Wed Jun  6 2007 Peter Lemenkov <lemenkov@gmail.com> 2.6.5-2
- Add BR libselinux-devel (bug #235145)
- Config files properly marked as config (bug #211122)

* Mon Apr 30 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.6.5-2_6
- Update to 2.6.5.

* Sat Apr 28 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.6.4-2_5
- Update to 2.6.4.

* Sun Feb  4 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.6.3-0_3
- Update to 2.6.3.

* Thu Feb  1 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.6.2-0_2
- Update to 2.6.2.

* Fri Jan 07 2007 Paulo Roma <roma@lcg.ufrj.br> 2.6.1-1_1
- Adapted for building kernel module.

* Tue Dec 26 2006 Peter Lemenkov <lemenkov@gmail.com> 2.6.1-1
- Ver. 2.6.1

* Sat Nov 25 2006 Peter Lemenkov <lemenkov@gmail.com> 2.6.0-2
- fixed nasty typo (see bug #217075)

* Fri Nov  3 2006 Peter Lemenkov <lemenkov@gmail.com> 2.6.0-1
- Ver. 2.6.0

* Sun Oct 29 2006 Peter Lemenkov <lemenkov@gmail.com> 2.5.3-5
- Fixed udev-rule again

* Sat Oct  7 2006 Peter Lemenkov <lemenkov@gmail.com> 2.5.3-4
- Fixed udev-rule

* Tue Sep 12 2006 Peter Lemenkov <lemenkov@gmail.com> 2.5.3-3%{?dist}
- Rebuild for FC6

* Wed May 03 2006 Peter Lemenkov <lemenkov@newmail.ru> 2.5.3-1%{?dist}
- Update to 2.5.3

* Thu Mar 30 2006 Peter Lemenkov <lemenkov@newmail.ru> 2.5.2-4%{?dist}
- rebuild

* Mon Feb 13 2006 Peter Lemenkov <lemenkov@newmail.ru> - 2.5.2-3
- Proper udev rule

* Mon Feb 13 2006 Peter Lemenkov <lemenkov@newmail.ru> - 2.5.2-2
- Added missing requires

* Tue Feb 07 2006 Peter Lemenkov <lemenkov@newmail.ru> - 2.5.2-1
- Update to 2.5.2
- Dropped fuse-mount.fuse.patch

* Wed Nov 23 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.4.2-1
- Use dist

* Wed Nov 23 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.4.2-1
- Update to 2.4.2 (solves CVE-2005-3531)
- Update README.fedora

* Sat Nov 12 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.4.1-3
- Add README.fedora
- Add hint to README.fedora and that you have to be member of the group "fuse"
  in the description
- Use groupadd instead of fedora-groupadd

* Fri Nov 04 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.4.1-2
- Rename packages a bit
- use makedev.d/40-fuse.nodes
- fix /sbin/mount.fuse
- Use a fuse group to restict access to fuse-filesystems

* Fri Oct 28 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.4.1-1
- Initial RPM release.
